# BeginTransaction

This function creates a Transaction object in its execution path that can be used by [ExecuteSQL](/reference/plugins/mysql/content/executesql.md) functions.

The transaction is automatically committed after all functions in the execution path complete.

If an SQL statement fails or returns an error, all SQL statements within the transaction are rolled back.

## Properties

### Connection string

The connection string that specifies how to connect to the database.

### Isolation level

The isolation level for the transaction. [Learn more](https://en.wikipedia.org/wiki/Isolation_\(database_systems\))

| Isolation Level           | Dirty Reads          | Non-Repeatable Reads | Phantom Reads        |
| ------------------------- | -------------------- | -------------------- | -------------------- |
| Read Uncommitted          | :white\_check\_mark: | :white\_check\_mark: | :white\_check\_mark: |
| Read Committed            | :x:                  | :white\_check\_mark: | :white\_check\_mark: |
| Repeatable Read (Default) | :x:                  | :x:                  | :white\_check\_mark: |
| Serializable              | :x:                  | :x:                  | :x:                  |

***

## Example

Suppose you have a sales order with multiple line items that need to be added to the database.

Using [ExecuteSQL](/reference/plugins/mysql/content/executesql.md) *without* **BeginTransaction** would create a new database connection for each item written to the database. By using **BeginTransaction**, all items are added within the same transaction.

If an error occurs during order creation, the entire transaction is rolled back, ensuring no incomplete orders are stored in the database. Adding multiple records within the same transaction also significantly improves execution speed.

**Steps:**

1. Add a **BeginTransaction** function to your Solution.
2. Set up the database connection for the **BeginTransaction** function.
3. Add your **ExecuteSQL** functions to your workflow.
4. For each **ExecuteSQL**, select the *Use transaction* property.
5. Set the *Transaction* property (only displayed when *Use transaction* property is selected) to 'BeginTransaction.Transaction'.

## Links

* [Wikipedia: Database transaction](https://en.wikipedia.org/wiki/Database_transaction)
* [Wikipedia: Isolation (database systems)](https://en.wikipedia.org/wiki/Isolation_\(database_systems\))


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.linx.software/reference/plugins/mysql/content/begintransaction.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
